=== modified file 'diff.py'
--- diff.py	2012-01-23 17:04:13 +0000
+++ diff.py	2012-01-23 17:04:56 +0000
@@ -395,6 +395,8 @@
     def _treeview_cursor_cb(self, *args):
         """Callback for when the treeview cursor changes."""
         (path, col) = self.treeview.get_cursor()
+        if path is None:
+            return
         specific_files = [ self.model[path][1] ]
         if specific_files == [ None ]:
             return

=== modified file 'tests/test_diff.py'
--- tests/test_diff.py	2011-09-03 20:58:34 +0000
+++ tests/test_diff.py	2012-01-23 17:04:56 +0000
@@ -32,9 +32,13 @@
 from bzrlib.plugins.gtk.diff import (
     DiffController,
     DiffView,
+    DiffWidget,
     iter_changes_to_status,
     MergeDirectiveController,
     )
+from bzrlib.plugins.gtk.tests import MockMethod
+
+
 eg_diff = """\
 === modified file 'tests/test_diff.py'
 --- tests/test_diff.py	2008-03-11 13:18:28 +0000
@@ -99,6 +103,23 @@
             )
 
 
+
+class FakeDiffWidget(DiffWidget):
+
+    SHOW_WIDGETS = False
+
+
+class TestDiffWidget(tests.TestCaseWithTransport):
+
+    def test_treeview_cursor_cbd_with_destroyed_treeview(self):
+        widget = FakeDiffWidget()
+        widget.set_diff_text_sections([('a', None, 'patch')])
+        MockMethod.bind(self, widget.diff_view, 'show_diff')
+        widget.treeview.destroy()
+        widget._treeview_cursor_cb(None)
+        self.assertFalse(widget.diff_view.show_diff.called)
+
+
 class MockDiffWidget(object):
 
     def set_diff_text_sections(self, sections):

